//S1_ListerNomsStyles_302f.js / CS3
// 02.12.08 / Hans Haesler, Chtelard 52, CH-1018 Lausanne

//Sert  mettre les noms des styles de paragraphes et/ou de caractres 
//dans deux blocs texte. Ces listes peuvent tre dites (supprimer des lignes 
//entires). Ensuite, lancer le script "S2_AttributsStyles", slectionner 
//l'astrisque dans le menu du dialogue. Puis "OK", et ce ne sont seulement les 
//attributs des styles des listes qui sont extraits et insrs dans un document.

//Important: Quand les styles sont groups, les noms des groupes doivent rester 
//intacts,  moins que tous les noms des styles seront supprims.
//Les noms des styles ne doivent pas tre modifis. C'est valable galement pour 
//les trois espaces insres devant chaque nom.

if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// mettre le point zero  zro/zro
app.documents[0].zeroPoint = [0,0];

// mettre le dfaut des styles de caractres  "Aucun"
var noCharStyle = app.documents[0].characterStyles.item(0);
app.documents[0].textDefaults.appliedCharacterStyle = noCharStyle;
// mettre le dfaut des styles de paragraphes  "Paragraphe standard"
var dfParaStyle = app.documents[0].paragraphStyles.item(1);
app.documents[0].textDefaults.appliedParagraphStyle = dfParaStyle;

// supprimer les blocs s'ils sont prsents (sinon un message d'erreur 
// sera gnr lors de l'xecution du script suivant)
try {
	app.documents[0].textFrames.item("ParaStyles").remove();
}
catch (e) {
}

try {
	app.documents[0].textFrames.item("CharStyles").remove();
}
catch (e) {
}

// vrifier la prsence de groupes de styles de paragraphes
paraGroups = app.documents[0].paragraphStyleGroups;
var nPSG = paraGroups.length;

// vrifier la prsence de groupes de styles de caractres
charGroups = app.documents[0].characterStyleGroups;
var nCSG = charGroups.length;

//--- dresser la liste des styles de paragraphes ---//
if (nPSG == 0) {
	var allParaStyles = app.documents[0].paragraphStyles.everyItem().name;
	// supprimer le premier lment
	allParaStyles.shift();
}
else {
	var allParaStyles = app.documents[0].paragraphStyles.everyItem().name;
	// insrer trois espaces devant chaque lment
	for (var i=0; i<allParaStyles.length; i++) {
		curName = "   " + allParaStyles[i];
		allParaStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	allParaStyles[0] = "[Root]";
	// une boucle  travers les groupes
	var curGroup;
	var curParaStyles;
	for (var i=0; i<nPSG; i++) {
		curGroup = paraGroups[i];
		curParaStyles = curGroup.paragraphStyles.everyItem().name;
		// insrer trois espaces devant chaque lment
		for (var k=0; k<curParaStyles.length; k++) {
			curName = "   " + curParaStyles[k];
			curParaStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curParaStyles = [curGroup.name].concat(curParaStyles);
		allParaStyles = allParaStyles.concat(curParaStyles);
	}
}

// convertir la liste en chane de texte
var paraString = allParaStyles.join("\r");

// crer un bloc texte 
var paraFrame = app.documents[0].pages[0].textFrames.add();
paraFrame.properties = {geometricBounds:[12, 15, 285, 105.5], fillColor:"Paper", label:"ParaStyles"};

// copier la chane prpare dans ce bloc
paraFrame.parentStory.contents = paraString;

//--- dresser la liste des style de caractres ---//
if (nCSG == 0) {
	var allCharStyles = app.documents[0].characterStyles.everyItem().name;
	// supprimer le premier lment
	allCharStyles.shift();
}
else {
	var allCharStyles = app.documents[0].characterStyles.everyItem().name;
	// insrer trois espaces devant chaque lment
	for (var i=0; i<allCharStyles.length; i++) {
		curName = "   " + allCharStyles[i];
		allCharStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	allCharStyles[0] = "[Root]";
	// une boucle  travers les groupes
	var curGroup;
	var curCharStyles;
	for (var i=0; i<nCSG; i++) {
		curGroup = charGroups[i];
		curCharStyles = curGroup.characterStyles.everyItem().name;
		// insrer trois espaces devant chaque lment
		for (var k=0; k<curCharStyles.length; k++) {
			curName = "   " + curCharStyles[k];
			curCharStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curCharStyles = [curGroup.name].concat(curCharStyles);
		allCharStyles = allCharStyles.concat(curCharStyles);
	}
}

// convertir la liste en chane de texte
var charString = allCharStyles.join("\r");

// crer un bloc texte 
var charFrame = app.documents[0].pages[0].textFrames.add();
charFrame.properties = {geometricBounds:[12, 109.5, 285, 200], fillColor:"Paper", label:"CharStyles"};

// copier la chane prpare dans ce bloc
charFrame.parentStory.contents = charString;